src/Entity/UserHasGame.php
<?php

namespace App\Entity;

use App\Repository\UserHasGameRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=UserHasGameRepository::class)
 */
class UserHasGame
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="date")
     */
    private $ownedDate;



    /**
     * @ORM\ManyToOne(targetEntity=Game::class, inversedBy="userHasGames")
     */
    private $Game;

    /**
     * @ORM\ManyToMany(targetEntity=Platform::class, inversedBy="userHasGames")
     */
    private $Platform;

    /**
     * @ORM\ManyToOne(targetEntity=User::class, inversedBy="UserHasGame")
     * @ORM\JoinColumn(nullable=false)
     */
    private $user;




    public function __construct()
    {
        $this->Platform = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getOwnedDate(): ?\DateTimeInterface
    {
        return $this->ownedDate;
    }

    public function setOwnedDate(\DateTimeInterface $ownedDate): self
    {
        $this->ownedDate = $ownedDate;

        return $this;
    }

    public function getGame(): ?Game
    {
        return $this->Game;
    }

    public function setGame(?Game $Game): self
    {
        $this->Game = $Game;

        return $this;
    }

    /**
     * @return Collection|Platform[]
     */
    public function getPlatform(): Collection
    {
        return $this->Platform;
    }

    public function addPlatform(Platform $platform): self
    {
        if (!$this->Platform->contains($platform)) {
            $this->Platform[] = $platform;
        }

        return $this;
    }

    public function removePlatform(Platform $platform): self
    {
        $this->Platform->removeElement($platform);

        return $this;
    }

    public function getUser(): ?User
    {
        return $this->user;
    }

    public function setUser(?User $user): self
    {
        $this->user = $user;

        return $this;
    }
}

src/Form/UserHasGameType.php
<?php

namespace App\Form;

use App\Entity\UserHasGame;
use App\Entity\Game;
use App\Entity\Platform;
use App\Entity\User;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;

class UserHasGameType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('ownedDate')
            ->add('Game', EntityType::class, [
                'class' => Game::class,
                'choice_label' => 'titleGame',
                'multiple' => false,
                'expanded' => true,
              
            ])
            ->add('Platform', EntityType::class, [
                'class' => Platform::class,
                'choice_label' => 'namePlat',
                'multiple' => true,
                'expanded' => true,
              
            ])

          
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => UserHasGame::class,
        ]);
    }
}

src/Controller/UserHasGameController.php
<?php

namespace App\Controller;

use App\Entity\UserHasGame;
use App\Form\UserHasGameType;
use App\Repository\PlatformRepository;
use App\Repository\TypeRepository;
use App\Repository\UserHasGameRepository;


use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\Validator\Constraints\Length;

/**
 * @Route("/userGame")
 */
class UserHasGameController extends AbstractController
{
    /**
     * @Route("/", name="user_has_game_index", methods={"GET"})
     */
    public function index(Request $request, UserHasGameRepository $userHasGameRepository, PlatformRepository $platformRepository, TypeRepository $typeRepository): Response
    {
        $user = $this->getUser();


        if ($request->get('ordone') !== null) {
            $ordone = $request->get('ordone');
        } else {
            $ordone = 'ASC';
        }

 
     if ($request->query->keys() !== []) {

            if ($request->get('platforme') !== null) {
                $maPlatforme = $request->get('platforme');
            } else {
                $maPlatforme = true;
            }

            if ($request->get('type') !== null) {
                $monType = $request->get('type');
            } else {
                $monType = true;
            }

            $userGames = $userHasGameRepository->getGamesFromUserAll($user, $monType, $maPlatforme,$ordone);
        } else {
            $userGames = $userHasGameRepository->getGamesFromUser($user,$ordone);
    }



        $platformes = $platformRepository->findAll();
        $types = $typeRepository->findAll();


        return $this->render('user_has_game/index.html.twig', [
            'user_has_games' => $userGames,
            'plat' =>  $platformes,
            'types' =>  $types,

        ]);
    }

    /**
     * @Route("/new", name="user_has_game_new", methods={"GET","POST"})
     */
    public function new(Request $request): Response
    {
        $userHasGame = new UserHasGame();
        $form = $this->createForm(UserHasGameType::class, $userHasGame);
        $form->handleRequest($request);



        $userHasGame->setUser($this->getUser());


        if ($form->isSubmitted() && $form->isValid()) {


            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($userHasGame);
            $entityManager->flush();

            return $this->redirectToRoute('user_has_game_index');
        }

        return $this->render('user_has_game/new.html.twig', [
            'user_has_game' => $userHasGame,
            'form' => $form->createView(),

        ]);
    }

    /**
     * @Route("/{id}", name="user_has_game_show", methods={"GET"})
     */
    public function show(UserHasGame $userHasGame): Response
    {
        return $this->render('user_has_game/show.html.twig', [
            'user_has_game' => $userHasGame,
        ]);
    }

    /**
     * @Route("/{id}/edit", name="user_has_game_edit", methods={"GET","POST"})
     */
    public function edit(Request $request, UserHasGame $userHasGame): Response
    {
        $form = $this->createForm(UserHasGameType::class, $userHasGame);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('user_has_game_index');
        }

        return $this->render('user_has_game/edit.html.twig', [
            'user_has_game' => $userHasGame,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="user_has_game_delete", methods={"POST"})
     */
    public function delete(Request $request, UserHasGame $userHasGame): Response
    {
        if ($this->isCsrfTokenValid('delete' . $userHasGame->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($userHasGame);
            $entityManager->flush();
        }

        return $this->redirectToRoute('user_has_game_index');
    }
}

templates/user_has_game/_delete_form.html.twig
<form method="post" action="{{ path('user_has_game_delete', {'id': user_has_game.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ user_has_game.id) }}">
    <button class="btn">Delete</button>
</form>

templates/user_has_game/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

templates/user_has_game/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit UserHasGame{% endblock %}

{% block body %}
    <h1>Edit UserHasGame</h1>

    {{ include('user_has_game/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('user_has_game_index') }}">back to list</a>

    {{ include('user_has_game/_delete_form.html.twig') }}
{% endblock %}

templates/user_has_game/index.html.twig
{% extends 'userBase.html.twig' %}

{% block title %}Mes Jeux
{% endblock %}

{% block body %}
	<h1>Mes Jeux</h1>
	{#% do app.request.query.set('script2', true) %#}


	<form action="/userGame" method="get">
		{% for mesPlats in plat %}
			<label>
				<input type="radio" name="platforme" value={{mesPlats.namePlat}}>
				{{mesPlats.namePlat}}
			</label>

		{% endfor %}

		{% for mesTypes in types %}

			<label>
				<input type="radio" name="type" value={{mesTypes.titleType}}>
				{{mesTypes.titleType}}
			</label>

		{% endfor %}

		<input type="submit" value="valider">
	</form>
	{% set params = app.request.query.all %}
	{% if app.request.get('ordone') != null %}

		{% if app.request.get('ordone') == "DESC" %}
			{% set params = params|merge({'ordone': 'ASC'}) %}
		{% endif %}

		{% if app.request.get('ordone') == "ASC" %}
			{% set params = params|merge({'ordone': 'DESC'}) %}
		{% endif %}

	{% else %}
		{% set params = params|merge({'ordone': 'DESC'}) %}
	{% endif %}


	<a href={{ path('user_has_game_index', params)}}>
		Ranger par ordre alphabétique</a>

<div class="row">
	{% for user_has_game in user_has_games %}

		
			<div class="col-lg-4 col-md-6 mb-4">
				<div class="card h-100">
					<a href="#!"><img class="card-img-top" src="../uploads/image/{{user_has_game.game.imageGame }}" alt="..."/></a>
					<div class="card-body">
						<h4 class="card-title">{{ user_has_game.game.titleGame }}</h4>
						<p class="card-text">
							description :{{ user_has_game.game.descriptionGame }}
						</p>
						<p class="card-text">
							nombre de vente
							{{ user_has_game.game.nbSellGame }}</p>
						<p class="card-text">
							genre du jeux
							{% for type in user_has_game.game.types %}
								{{ type.titleType}}
							{% endfor %}
						</p>
						<p class="card-text"> {{ user_has_game.game.releasedAt ? user_has_game.game.releasedAt|date('Y-m-d') : '' }} </p>
						<p class="card-text">
							{% for platform in user_has_game.Platform %}
								{{platform.namePlat}}
							{% endfor %}
						</p>
					</div>
					<div class="card-footer">
						<small class="text-muted">
							<a href="{{ path('user_has_game_show', {'id': user_has_game.id}) }}">show</a>
							<a href="{{ path('user_has_game_edit', {'id': user_has_game.id}) }}">edit</a>
						</small>
					</div>
				</div>
</div>
			{% endfor %}

		</div>

		<a href="{{ path('user_has_game_new') }}">Create new</a>
	{% endblock %}

templates/user_has_game/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New UserHasGame{% endblock %}

{% block body %}
    <h1>Create new Game</h1>

    {{ include('user_has_game/_form.html.twig') }}

    <a href="{{ path('user_has_game_index') }}">back to list</a>
{% endblock %}

templates/user_has_game/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}UserHasGame{% endblock %}

{% block body %}
    <h1>UserHasGame</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ user_has_game.id }}</td>
            </tr>
            <tr>
                <th>OwnedDate</th>
                <td>{{ user_has_game.ownedDate ? user_has_game.ownedDate|date('Y-m-d') : '' }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('user_has_game_index') }}">back to list</a>

    <a href="{{ path('user_has_game_edit', {'id': user_has_game.id}) }}">edit</a>

    {{ include('user_has_game/_delete_form.html.twig') }}
{% endblock %}